//
// A modified version of the main() method found in the Java 1.1 grammar.
// To add your visitors to the program, go to near the end, and copy or
// replace the line "root.accept(new Visitor());" with your own visitor
//

import generated.*;
import visitor.*;

public class Pretty {
  public static void main(String args[]) {
    JavaParser parser;
    if (args.length == 0) {
      System.err.println("Java Parser Version 1.1:  Reading from standard " +
                         "input . . .");
      parser = new JavaParser(System.in);
    } else if (args.length == 1) {
      System.err.println("Java Parser Version 1.1:  Reading from file " +
                         args[0] + " . . .");
      try {
        parser = new JavaParser(new java.io.FileInputStream(args[0]));
      } catch (java.io.FileNotFoundException e) {
        System.err.println("Java Parser Version 1.1:  File " + args[0] +
                           " not found.");
        return;
      }
    } else {
      System.err.println("Java Parser Version 1.1:  Usage is one of:");
      System.err.println("         java JavaParser < inputfile");
      System.err.println("OR");
      System.err.println("         java JavaParser inputfile");
      return;
    }

    try {
      //
      // Here's where the AST actions and visiting take place.
      //
      Node root = parser.CompilationUnit();
      parser = null;
      System.err.println("Java Parser Version 1.1:  Java program parsed " +
                         "successfully.");
//      root.accept(new Visitor());
      root.accept(new PrettyPrinter());
    } catch (ParseException e) {
      System.err.println("Java Parser Version 1.1:  Encountered errors " +
                         "during parse." + e);
    }
  }
}
